'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = applyHigherOrder;

var _mudash = require('mudash');

var _mudash2 = _interopRequireDefault(_mudash);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function applyHigherOrder() {
  for (var _len = arguments.length, higherOrders = Array(_len), _key = 0; _key < _len; _key++) {
    higherOrders[_key] = arguments[_key];
  }

  return function (createStore) {
    return function (reducer, preloadedState, enhancer) {
      reducer = _mudash2.default.compose.apply(_mudash2.default, higherOrders)(reducer);
      return createStore(reducer, preloadedState, enhancer);
    };
  };
}
//# sourceMappingURL=applyHigherOrder.js.map
