'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = createChannel;

var _bluebird = require('bluebird');

var _bluebird2 = _interopRequireDefault(_bluebird);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function createChannel() {
  var messageQueue = [];
  var resolveQueue = [];

  function put(msg) {
    if (resolveQueue.length) {
      var nextResolve = resolveQueue.shift();
      nextResolve(msg);
    } else {
      messageQueue.push(msg);
    }
  }

  function take() {
    if (messageQueue.length) {
      return _bluebird2.default.resolve(messageQueue.shift());
    }
    return new _bluebird2.default(function (resolve) {
      return resolveQueue.push(resolve);
    });
  }

  return {
    take: take,
    put: put
  };
}
//# sourceMappingURL=createChannel.js.map
