'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = mapReducers;

var _mudash = require('mudash');

var _mudash2 = _interopRequireDefault(_mudash);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function mapReducers(mapped) {
  return function (previous) {
    for (var _len = arguments.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      args[_key - 1] = arguments[_key];
    }

    return _mudash2.default.reduce(mapped, function (current, reducer, path) {
      var currentPart = _mudash2.default.get(current, path);
      var nextPart = reducer.apply(undefined, [current].concat(args));
      if (_mudash2.default.isEqual(currentPart, nextPart)) {
        return current;
      }
      return _mudash2.default.assoc(current, path, nextPart);
    }, previous);
  };
}
//# sourceMappingURL=mapReducers.js.map
